% !TEX root = main.tex

\section{Evaluation}
\label{section:evaluation}

To validate our design choices and demonstrate the ability
of D-Cliques to remove the effect of label skew, we focus
our investigation on concrete experiments. This is complementary to existing theoretical analyses of D-SGD, which hold for D-Cliques but are unable to capture its benefits. Indeed, in these formal convergence results, the effect of data heterogeneity is abstracted
away with the use of unknown constants that bound the
variance of local gradients, and the effect of topology is
analyzed independently~\cite{lian2017d-psgd,Lian2018,neglia2020,ying2021exponential}. In contrast, our experiments show that a careful data-dependent design of the
 topology significantly improves the convergence speed under data heterogeneity, suggesting that the usually overlooked constants and the interplay with topology have a major impact. Our experiments have motivated refined analyses that can theoretically explain the benefits of our approach~\cite{bars2022yes,dandi2022mixing}.

Below, we first describe our experimental setup. We then
compare D-Cliques to alternative topologies to
show the benefits and relevance of our main design choices. We also evaluate
different inter-clique topologies to further reduce the number of
inter-clique connections so as to gracefully scale with the number of
nodes. Then, we further show the impact of removing intra-clique edges.
 Finally, we show that Greedy Swap
(Alg.~\ref{Algorithm:greedy-swap}) 
constructs cliques efficiently with consistently lower skew than
random cliques.

\subsection{Experimental Setup}
\label{section:experimental-settings}

Our main goal is to provide a fair comparison of the convergence speed across
different topologies and algorithmic variations, in order to validate our
design choices and
show that D-Cliques can remove much of the effects of label distribution skew. 

In our study, we focus our investigation on the convergence speed, rather than
the final accuracy after a fixed number of iterations.
% we focus our investigation on concrete experiments, rather than asymptotic convergence analysis, and convergence speed, rather than final accuracy, for two reasons. First, when using asymptotic convergence analysis, the effect of heterogeneous data on the variance of gradients is typically abstracted
% with the use of bounded but unknown constants (e.g.~\cite{ying2021exponential}). As the next experiments
% show, a careful design of the topology significantly effect the convergence speed, which seems to indicate that the usually overlooked constants have a major impact.
Indeed, depending on when training is stopped, the relative 
difference in final accuracy across different algorithms may vary
significantly and lead to different conclusions. Instead of relying on
somewhat arbitrary stopping points, we show the convergence curves of
generalization performance (i.e., the accuracy on the test set throughout
training), up to a point where it is clear that the different approaches have
converged, will not make significantly more progress, or behave essentially
the same. 
% approach
% clearly converges faster and/or the other approaches are essentially similar, everything else being exactly the same.
% Formalizing the underlying factors is outside the scope of this paper, but shall be greatly informed by the concrete experiments that we present.

\paragraph{Datasets} We experiment with two datasets: MNIST~
\cite{mnistWebsite} and
CIFAR10~\cite{krizhevsky2009learning}, which both have $L=10$ classes.
For MNIST,  we use 50k and 10k examples from the original 60k training 
set for training and validation respectively. We use all 10k examples of 
the test set to measure prediction accuracy.  The validation set preserves the
original unbalanced ratio of the classes in the test set, and the remaining
examples become the training set.
For CIFAR10, classes are evenly balanced: we initially used 45k/50k images 
of the original training set for training, 5k/50k for validation, and all 10k examples 
of the test set for measuring prediction accuracy. After tuning hyper-parameters
on initial experiments, we then used all 50k images of the original training set
for training for all experiments, as the 45k did not split evenly in 1000 nodes
with the partitioning scheme explained in the next paragraph.

For both MNIST and CIFAR10, we use the heterogeneous data partitioning scheme
proposed by \text{McMahan et al.}~\cite{mcmahan2016communication} 
in their seminal FL work: 
we sort all training examples by class, then split the list into shards of
equal size, and randomly assign two shards to each node. When the number of
examples of one class does not divide evenly in shards, as is the case for MNIST, some shards may have examples of more than one class and therefore nodes may have examples
of up to 4 classes. However, most nodes will have examples of 2 classes.  The varying number 
of classes, as well as the varying distribution of examples within a single node, makes the task 
of creating cliques with low skew nontrivial.

\paragraph{Models}
We
use a logistic regression classifier for MNIST, which
provides up to 92.5\% accuracy in the centralized setting.
For CIFAR10, we use a Group-Normalized variant of LeNet~\cite{quagmire}, a
deep convolutional network which achieves an accuracy of $74.15\%$ in the
centralized setting.
These models are thus reasonably accurate (which is sufficient to
study the effect of the topology) while being sufficiently fast to train in a
fully decentralized setting and simple enough to configure and analyze.
Regarding hyper-parameters, we jointly optimize the learning rate and
mini-batch size on the
validation set for 100 nodes, obtaining respectively $0.1$ and $128$ for
MNIST and $0.002$ and $20$ for CIFAR10.
For CIFAR10, we additionally use a momentum of $0.9$.

\paragraph{Metrics}
We evaluate 100- and 1000-node networks by
creating multiple models
in memory and simulating the exchange of messages between nodes.
To ignore the impact of distributed execution strategies and system
optimization techniques, we report the test accuracy of all nodes (min, max,
average) as a function of the number of times each example of the dataset has
been sampled by a node, i.e. an \textit{epoch}. This is equivalent to the classic 
case of a single node sampling the full distribution.
To further make results comparable across different number of nodes, we lower
the batch size proportionally to the number of nodes added, and inversely,
e.g. on MNIST, 128 with 100 nodes vs. 13 with 1000 nodes. This
ensures the same number of model updates and averaging per epoch, allowing a
fair comparison.\footnote{Updating and averaging models
after every example can eliminate the impact of label distribution skew. However, the
resulting communication overhead is impractical.}

\paragraph{Baselines} We compare our results against an ideal
baseline:
a fully-connected network topology with the same number of nodes. All other
things being equal, any other topology using less edges will converge
at the same speed or slower: \textit{this is therefore the most difficult and general baseline to compare against}.
This baseline is also essentially equivalent to a centralized (single) IID node using a batch size
$n$ times bigger, where $n$ is the number of nodes.  Both a fully-connected network and a single IID node
 effectively optimize a single model and sample
uniformly from the global distribution: both thus remove entirely the
effect of label distribution skew and of the network topology on the
optimization. In practice, we prefer a
fully-connected network because it
 converges slightly faster and obtains slightly 
better final accuracy than a single node sampling randomly from the global
distribution.\footnote{We 
conjecture that an heterogeneous data partition in a fully-connected network may force 
more balanced representation of all classes in the union of all mini-batches, leading to better convergence.}

We also provide comparisons against popular sparse topologies, such as random
graphs and exponential graphs \cite{ying2021exponential}.

\subsection{D-Cliques Match the Convergence Speed of Fully-Connected with a
Fraction of the Edges}
\label{section:d-cliques-vs-fully-connected}

In this first experiment, we show that D-Cliques with Clique Averaging (and
momentum when mentioned) converges 
almost as fast as a fully-connected network on both MNIST and CIFAR10. Figure~\ref{fig:convergence-speed-dc-vs-fc-2-shards-per-node} 
illustrates the convergence speed of D-Cliques with $n=100$ nodes on MNIST (with Clique Averaging) 
and CIFAR10 (with Clique Averaging and momentum). Observe that the convergence speed is
very close to that of a fully-connected topology, and significantly better than with
a ring or a grid (see Figure~\ref{fig:iid-vs-non-iid-problem}). 
It also has less variance than both the ring and grid. 

% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name fully-connected d-cliques/greedy-swap --nodes:name 2-shards-uneq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-23:16:47-CEST-labostrex117 all/2021-09-28-23:18:49-CEST-labostrex119 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 80 --ymax 92.5 --yaxis test-accuracy --labels 'fully-connected' 'd-cliques (fc) w/ cliq-avg' --save-figure ../mlsys2022style/figures/convergence-speed-mnist-dc-fc-vs-fc-2-shards-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3
% CIFAR10
% python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name fully-connected d-cliques/greedy-swap --nodes:name 2-shards-eq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-02-18:58:22-CEST-labostrex114 all/2021-10-03-19:53:21-CEST-labostrex117 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 100 --yaxis test-accuracy --labels 'fully-connected' 'd-cliques (fc) w/ c-avg' --save-figure ../mlsys2022style/figures/convergence-speed-cifar10-dc-fc-vs-fc-2-shards-per-node.png --linestyles 'solid' 'dashed' --legend 'lower right' --font-size 18 --linewidth 3

\begin{figure}[htbp]
    \centering        
    \begin{subfigure}[b]{0.23\textwidth}
    \centering
    \includegraphics[width=\textwidth]{figures/convergence-speed-mnist-dc-fc-vs-fc-2-shards-per-node}
    \caption{\label{fig:convergence-speed-mnist-dc-fc-vs-fc-2-shards-per-node} MNIST}
    \end{subfigure}
    \hfill
    \begin{subfigure}[b]{0.23\textwidth}
    \centering
    \includegraphics[width=\textwidth]{figures/convergence-speed-cifar10-dc-fc-vs-fc-2-shards-per-node}
    \caption{
    \label{fig:convergence-speed-cifar10-dc-fc-vs-fc-2-shards-per-node} CIFAR10 (w/ momentum)}
    \end{subfigure}
\caption{\label{fig:convergence-speed-dc-vs-fc-2-shards-per-node} Comparison on 100 heterogeneous nodes (2 shards/node)
between a fully-connected network and D-Cliques (fully-connected) constructed with Greedy Swap (10 cliques of 10 nodes) using
Clique Averaging. Bold line is the average accuracy over
all nodes. Thinner upper and lower lines are maximum and minimum accuracy over
all nodes.}
\end{figure}


\subsection{Clique Averaging is Beneficial and Sometimes Necessary}
\label{sec:exp:clique_avg}

In this experiment, we perform an ablation study of the effect of Clique Averaging.
Figure~\ref{fig:d-clique-mnist-clique-avg} shows that Clique Averaging
(\autoref{Algorithm:Clique-Unbiased-D-PSGD})
 reduces the variance of models across nodes and slightly accelerates the
convergence on MNIST. Recall that Clique Averaging induces a small
additional cost, as gradients
and models need to be sent in two separate rounds of messages. 
Nonetheless, compared to fully connecting all nodes, the total number 
of messages per round for 100 nodes is reduced by $\approx 80\%$.
% (see
% Section~\ref{section:interclique-topologies} and \ref{section:clique-averaging-momentum}).

% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name d-cliques/greedy-swap --nodes:name 2-shards-uneq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-23:18:49-CEST-labostrex119 all/2021-09-29-03:53:42-CEST-labostrex119  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 89 --ymax 92.5 --yaxis test-accuracy --labels 'd-cliques (fc) w/ c-avg.'  'd-cliques (fc) w/o c-avg.' --save-figure ../mlsys2022style/figures/convergence-speed-mnist-dc-no-c-avg-vs-c-avg-2-shards-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 2.5
\begin{figure}[htbp]
         \centering
         \includegraphics[width=0.23\textwidth]{figures/convergence-speed-mnist-dc-no-c-avg-vs-c-avg-2-shards-per-node}
\caption{\label{fig:d-clique-mnist-clique-avg} MNIST: Effect of Clique Averaging on D-Cliques (fully-connected) with 10 cliques of 10 heterogeneous nodes (100 nodes). Y axis starts at 89.}
\end{figure}

%% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name d-cliques/greedy-swap --nodes:name 2-shards-uneq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
%% python $TOOLS/analyze/diff.py --rundirs all/2021-09-29-03:53:42-CEST-labostrex119 all/2021-09-28-23:18:49-CEST-labostrex119 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --yaxis test-accuracy --labels 'd-cliques (fc) w/o c-avg.' 'd-cliques (fc) w/ c-avg.' --save-figure ../mlsys2022style/figures/consensus-distance-mnist-dc-no-c-avg-vs-c-avg-2-shards-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 2.5 --ymax 0.15 --yaxis consensus-distance
%\begin{figure}[htbp]
%         \centering
%         \includegraphics[width=0.23\textwidth]{figures/consensus-distance-mnist-dc-no-c-avg-vs-c-avg-2-shards-per-node}
%\caption{\label{fig:d-clique-mnist-clique-avg-consensus-distance} Consensus distance of experiments in \autoref{fig:d-clique-mnist-clique-avg}.}
%\end{figure}


The effect of Clique Averaging is much more pronounced on CIFAR10, as can
be seen in
Figure~\ref{fig:cifar10-c-avg-momentum}, especially when used in combination with momentum.
Without Clique Averaging,
the use of momentum is actually detrimental. With Clique Averaging, the 
situation reverses and momentum is again beneficial. The combination
of both has the fastest convergence speed and the lowest variance among all
four possibilities. We believe that the gains obtained with Clique
Averaging are larger on CIFAR10 than on MNIST because the model we train on
CIFAR10 (a deep convolutional network) has much higher capacity than the
linear model used for MNIST. The resulting highly nonconvex objective increases the
sensitivity of local updates to small differences in the gradients, making
them point in different directions, as observed by \text{Kong et al.}~\cite{consensus_distance}
even in the homogeneous setting.
Clique Averaging helps to reduce this effect by reducing the bias in
local gradients.

% CIFAR10
%  python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name d-cliques/greedy-swap --nodes:name 2-shards-eq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% w/o Clique Averaging
% python $TOOLS/analyze/diff.py --rundirs  all/2021-10-04-03:13:46-CEST-labostrex117 all/2021-10-03-23:37:42-CEST-labostrex117  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 100 --yaxis test-accuracy --labels  'd-cliques (fc) w/ momentum'  'd-cliques (fc) w/o momentum' --save-figure ../mlsys2022style/figures/convergence-speed-cifar10-wo-c-avg-no-mom-vs-mom-2-shards-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3
% w/ Clique Averaging
% python $TOOLS/analyze/diff.py --rundirs  all/2021-10-03-19:53:21-CEST-labostrex117 all/2021-10-03-16:10:34-CEST-labostrex117 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 100 --yaxis test-accuracy --labels  'd-cliques (fc) w/ momentum' 'd-cliques (fc) w/o momentum' --save-figure ../mlsys2022style/figures/convergence-speed-cifar10-w-c-avg-no-mom-vs-mom-2-shards-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3 --legend 'lower right'

\begin{figure}[htbp]
    \centering        
    \begin{subfigure}[b]{0.23\textwidth}
    \centering
    \includegraphics[width=\textwidth]{figures/convergence-speed-cifar10-wo-c-avg-no-mom-vs-mom-2-shards-per-node}
    \caption{\label{fig:convergence-speed-cifar10-wo-c-avg-no-mom-vs-mom-2-shards-per-node} Without Clique Averaging }
    \end{subfigure}
    \hfill
    \begin{subfigure}[b]{0.23\textwidth}
    \centering
    \includegraphics[width=\textwidth]{figures/convergence-speed-cifar10-w-c-avg-no-mom-vs-mom-2-shards-per-node}
    \caption{\label{fig:convergence-speed-cifar10-w-c-avg-no-mom-vs-mom-2-shards-per-node} With Clique Averaging}
    \end{subfigure}
\caption{\label{fig:cifar10-c-avg-momentum} CIFAR10: Effect of Clique Averaging, without and with
momentum, on D-Cliques (fully-connected) with 10 cliques of 10 heterogeneous nodes (100 nodes).}
\end{figure}

%% w/o Clique Averaging
%% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-23:37:42-CEST-labostrex117 all/2021-10-04-03:13:46-CEST-labostrex117  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --labels 'd-cliques (fc) w/o momentum' 'd-cliques (fc) w/ momentum' --save-figure ../mlsys2022style/figures/consensus-distance-cifar10-wo-c-avg-no-mom-vs-mom-2-shards-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3 --yaxis consensus-distance --ymax 0.6
%% w/ Clique Averaging
%% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-16:10:34-CEST-labostrex117 all/2021-10-03-19:53:21-CEST-labostrex117 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --labels 'd-cliques (fc) w/o momentum' 'd-cliques (fc) w/ momentum' --save-figure ../mlsys2022style/figures/consensus-distance-cifar10-w-c-avg-no-mom-vs-mom-2-shards-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3 --legend 'lower right' --yaxis consensus-distance --ymax 0.6 --legend 'upper right'
%
%\begin{figure}[htbp]
%    \centering        
%    \begin{subfigure}[b]{0.23\textwidth}
%    \centering
%    \includegraphics[width=\textwidth]{figures/consensus-distance-cifar10-wo-c-avg-no-mom-vs-mom-2-shards-per-node}
%    \caption{\label{fig:consensus-distance-cifar10-wo-c-avg-no-mom-vs-mom-2-shards-per-node} Without Clique Averaging }
%    \end{subfigure}
%    \hfill
%    \begin{subfigure}[b]{0.23\textwidth}
%    \centering
%    \includegraphics[width=\textwidth]{figures/consensus-distance-cifar10-w-c-avg-no-mom-vs-mom-2-shards-per-node}
%    \caption{\label{fig:consensus-distance-cifar10-w-c-avg-no-mom-vs-mom-2-shards-per-node} With Clique Averaging}
%    \end{subfigure}
%\caption{\label{fig:cifar10-c-avg-momentum-consensus-distance} Consensus distance of experiments in \autoref{fig:cifar10-c-avg-momentum}.}
%\end{figure}

\subsection{D-Cliques Converge Faster than Random and Exponential Graphs}
\label{section:d-cliques-vs-random-graphs}

In this experiment, we compare D-Cliques to a random graph and an exponential
graph~\cite{ying2021exponential}.

For the random graph, we use a similar 
number of edges (10) per node to determine
whether a simple sparse topology could work equally well. 
To ensure a fair comparison, because a random graph does not support 
Clique Averaging, we do not use it for D-Cliques either.
\autoref{fig:convergence-random-vs-d-cliques-2-shards} 
shows that even \textit{without} Clique Averaging, D-Cliques converge faster and with
lower variance. Furthermore, the use of momentum in a random graph
is detrimental, similar to D-Cliques without the use of Clique Averaging 
(see \autoref{fig:convergence-speed-cifar10-wo-c-avg-no-mom-vs-mom-2-shards-per-node}). 
D-Cliques converge faster and with less variance even
if we force the local neighborhoods of the random graph to be representative
of the global label distribution
(see the appendix of the extended version of this paper~\cite{dcliques-arxiv}, as the experiment requires a
different data partitioning scheme for a fair
comparison).
% The clustering structure of D-Cliques therefore provides
% faster convergence.
% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name random-graph expander-graph d-cliques/greedy-swap --nodes:name 2-shards-uneq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-29-03:53:42-CEST-labostrex119 all/2021-09-29-22:17:08-CEST-labostrex118 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 80 --ymax 92.5 --yaxis test-accuracy --labels 'd-cliques (fc) w/o cliq-avg'  'random 10'  --save-figure ../icdcs22/figures/convergence-mnist-random-vs-d-cliques-2-shards.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3

% CIFAR10
% python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name d-cliques/greedy-swap random-graph --nodes:nb-nodes 100 --algorithm:learning-momentum 0.9  | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-23:37:42-CEST-labostrex117 all/2021-10-05-18:38:30-CEST-labostrex115 all/2021-10-05-23:09:38-CEST-labostrex115 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 100 --yaxis test-accuracy --labels 'd-cliques (fc) w/o cliq-avg w/o mom.'  'random 10 w/o mom.' 'random 10 w/ mom.' --save-figure ../icdcs22/figures/convergence-cifar10-random-vs-d-cliques-2-shards.png --linestyles 'solid' 'dashed' 'dotted' 'dashdot' --font-size 18 --linewidth 3

\begin{figure}[htbp]
     \centering     
         \begin{subfigure}[b]{0.23\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/convergence-mnist-random-vs-d-cliques-2-shards}
                  \caption{MNIST}
         \end{subfigure}
                 \hfill                      
        \begin{subfigure}[b]{0.23\textwidth}
        \centering
         \includegraphics[width=\textwidth]{figures/convergence-cifar10-random-vs-d-cliques-2-shards}
         \caption{CIFAR10}
     \end{subfigure} 
 \caption{\label{fig:convergence-random-vs-d-cliques-2-shards} Comparison on 100 heterogeneous nodes between D-Cliques (fully-connected) with 10 cliques of size 10 and a random graph with 10 edges per node \textit{without} Clique Averaging or momentum.} 
\end{figure}

For the exponential graph, we follow 
% we compare against the one used by Ying et
% al.~\cite{ying2021exponential}, that results in a large spectral gap and low communication cost, with claims that it asymptotically provides exact averaging while communicating with only a logarithmic number of neighbors.
the deterministic construction of~\cite{ying2021exponential} and consider
edges to be undirected as required by D-SGD, resulting in 14 edges per
node.
% connections induced by
% the static expander graph for every communication step instead of a single neighbor chosen in a round-robin fashion.
\autoref{fig:convergence-expander-vs-d-cliques-2-shards} shows that D-Cliques
converge faster and with less variance, despite the exponential graph having
1.4 times more edges.
% has
% the benefit of 14 times more communication than used in~\cite{ying2021exponential} and 4 more edges per node than D-Cliques.
% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name expander-graph d-cliques/greedy-swap --nodes:name 2-shards-uneq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-29-03:53:42-CEST-labostrex119 all/2022-01-26-10:37:26-CET-labostrex113 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 80 --ymax 92.5 --yaxis test-accuracy --labels 'd-cliques (fc) w/o cliq-avg'  'expander 14' --save-figure ../icdcs22/figures/convergence-mnist-expander-vs-d-cliques-2-shards.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3

% CIFAR10
% python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name d-cliques/greedy-swap expander-graph --nodes:nb-nodes 100 --algorithm:learning-momentum 0.9  | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-23:37:42-CEST-labostrex117 all/2022-01-26-17:16:09-CET-labostrex112 all/2022-01-26-22:03:05-CET-labostrex112 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 100 --yaxis test-accuracy --labels 'd-cliques (fc) w/o cliq-avg w/o mom.'  'expander 14 w/o mom.' 'expander 14 w/ mom.' --save-figure ../icdcs22/figures/convergence-cifar10-expander-vs-d-cliques-2-shards.png --linestyles 'solid' 'dashed' 'dotted' 'dashdot' --font-size 18 --linewidth 3

\begin{figure}[htbp]
     \centering     
         \begin{subfigure}[b]{0.23\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/convergence-mnist-expander-vs-d-cliques-2-shards}
                  \caption{MNIST}
         \end{subfigure}
                 \hfill                      
        \begin{subfigure}[b]{0.23\textwidth}
        \centering
        \includegraphics[width=\textwidth]{figures/convergence-cifar10-expander-vs-d-cliques-2-shards}
         \caption{CIFAR10}
     \end{subfigure} 
 \caption{\label{fig:convergence-expander-vs-d-cliques-2-shards} Comparison on
 100 heterogeneous nodes between D-Cliques (fully-connected) with 10 cliques
 of size 10 and an exponential graph with 14 undirected edges per node 
 \textit{without} Clique Averaging or momentum.} 
\end{figure}

% Moreover, D-Cliques converge similarly or faster than a random graph constructed with diverse neighborhoods, such that the neighborhood of each node has zero skew. \autoref{fig:convergence-random-vs-d-cliques-1-class-per-node} shows results for similar experiments as \autoref{fig:convergence-random-vs-d-cliques-2-shards}, with nodes having examples of only 1 class instead of up to 4, to make the creation of diverse neighborhoods with zero skew easier. Note that in this case the effect of data heterogeneity on convergence is actually stronger. On MNIST, a random graph with a diverse neighborhood is marginally better than D-Cliques without Clique Averaging. We hypothesize that the slightly better mixing provided by the random graph, compared to cliques, provides a small edge. On CIFAR10, when using momentum, D-Cliques converge faster even without Clique Averaging. In this case, it seems the clustering has a more beneficial effect than the marginal gain in mixing of the random graph. For both MNIST and CIFAR10, the clustering provided by D-Cliques, in combination with Clique Averaging, provides faster convergence and lower variance than diverse neighborhoods. In practice, the difficulty of obtaining a random graph in which each node has a neighborhood with similar skew as D-Cliques, while not using more edges, actually makes the construction with a decentralized algorithm harder, because there are more constraints in selecting potential candidates for swapping.

% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name random-graph d-cliques/ideal greedy-diverse-random  --nodes:name max-local-skew --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-23:18:40-CEST-labostrex118 all/2021-09-29-03:52:47-CEST-labostrex118  all/2021-10-11-18:32:25-CEST-labostrex113 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 87 --ymax 93 --yaxis test-accuracy --labels 'd-cliques (fc) w/ cliq-avg'  'd-cliques (fc) w/o cliq-avg'  'random 10 (diverse neighbors)'  --save-figure ../icdcs22/figures/convergence-mnist-random-vs-d-cliques-1-class-per-node.png --linestyles 'solid' 'dashed' 'dotted' 'dashdot' 'solid' --markers '' '' '' '' 'o' --font-size 18 --linewidth 3

% CIFAR10
% python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name random-graph d-cliques/ideal greedy-diverse-random  --nodes:name max-local-skew  --nodes:nb-nodes 100 --algorithm:learning-momentum 0.9  | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-19:45:14-CEST-labostrex118 all/2021-10-04-02:50:28-CEST-labostrex118 all/2021-10-12-02:54:13-CEST-labostrex112  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 119 --yaxis test-accuracy --labels 'd-cliques (fc) w/ cliq-avg'  'd-cliques (fc) w/o cliq-avg' 'random 10 (diverse neighbors)' --save-figure ../icdcs22/figures/convergence-cifar10-random-vs-d-cliques-1-class-per-node.png --linestyles 'solid' 'dashed' 'dotted' 'dashdot' 'solid' --markers '' '' '' '' 'o'  --font-size 18 --linewidth 3

% \begin{figure}[htbp]
%      \centering     
%          \begin{subfigure}[b]{0.23\textwidth}
%          \centering
%          \includegraphics[width=\textwidth]{figures/convergence-mnist-random-vs-d-cliques-1-class-per-node}
%                   \caption{MNIST}
%          \end{subfigure}
%                  \hfill                      
%         \begin{subfigure}[b]{0.23\textwidth}
%         \centering
%          \includegraphics[width=\textwidth]{figures/convergence-cifar10-random-vs-d-cliques-1-class-per-node}
%          \caption{CIFAR10}
%      \end{subfigure} 
%  \caption{\label{fig:convergence-random-vs-d-cliques-1-class-per-node} Comparison to variations of Random Graph with 10 edges per node on 100 nodes (variation of \autoref{fig:convergence-random-vs-d-cliques-2-shards} with 1 class/node instead of 2 shards/node as well as constraining the random graph so the neighborhood of each node has zero skew).} 
% \end{figure}

These experiments show that a careful design of the topology is indeed
necessary, especially regarding the skew in the neighborhood of each node. In
addition, it appears that the ``bounded data heterogeneity'' assumption,
typically used in convergence theorems to compare different algorithms and
topologies~\cite{lian2017d-psgd,Lian2018,neglia2020,ying2021exponential},
overlooks the major role that the choice of topology (e.g., one that ensures
clustered representative neighborhoods like D-Cliques) may have on the
convergence speed.
%% From directory 'results-v2':
%% MNIST
%% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name random-graph d-cliques/greedy-swap greedy-neighbourhood-swap --nodes:name 2-shards-uneq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
%% python $TOOLS/analyze/diff.py --rundirs all/2021-09-29-03:53:42-CEST-labostrex119 all/2021-09-29-22:17:08-CEST-labostrex118 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --labels 'd-cliques (fc) w/o cliq-avg'  'random 10' --save-figure ../mlsys2022style/figures/consensus-distance-mnist-random-vs-d-cliques-2-shards.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3 --yaxis consensus-distance --ymax 0.6
%
%% CIFAR10
%% python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name d-cliques/greedy-swap random-graph --nodes:nb-nodes 100 --algorithm:learning-momentum 0.9  | python $TOOLS/analyze/diff.py
%% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-23:37:42-CEST-labostrex117 all/2021-10-05-18:38:30-CEST-labostrex115 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --labels 'd-cliques (fc) w/o cliq-avg w/o mom.'  'random 10 w/o mom.' --save-figure ../mlsys2022style/figures/consensus-distance-cifar10-random-vs-d-cliques-2-shards.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3 --yaxis consensus-distance --ymax 0.15
%
%\begin{figure}[htbp]
%     \centering     
%         \begin{subfigure}[b]{0.23\textwidth}
%         \centering
%         \includegraphics[width=\textwidth]{figures/consensus-distance-mnist-random-vs-d-cliques-2-shards}
%                  \caption{MNIST}
%         \end{subfigure}
%                 \hfill                      
%        \begin{subfigure}[b]{0.23\textwidth}
%        \centering
%         \includegraphics[width=\textwidth]{figures/consensus-distance-cifar10-random-vs-d-cliques-2-shards}
%         \caption{CIFAR10}
%     \end{subfigure} 
% \caption{\label{fig:consensus-distance-random-vs-d-cliques-2-shards} Consensus distance of experiments in \autoref{fig:convergence-random-vs-d-cliques-2-shards}.} 
%\end{figure}


\subsection{D-Cliques Scale with Sparser Inter-Clique Topologies}
\label{section:scaling}

In this experiment, we explore the trade-offs between scalability and
convergence speed induced by the several sparse inter-clique topologies
introduced in Section~\ref{section:interclique-topologies}.
\autoref{fig:d-cliques-scaling-mnist-1000} and \autoref{fig:d-cliques-scaling-cifar10-1000}  
show the convergence speed  respectively on MNIST and CIFAR10 on a larger network of 1000 nodes, 
compared to the ideal baseline of a
fully-connected network representing
the fastest convergence speed achievable if topology had no impact. Among the linear schemes, the ring
topology converges but is much slower than our fractal scheme. Among the super-linear schemes, the small-world
topology has a convergence speed that is almost the same as with a
fully-connected inter-clique topology but with 22\% less edges
(14.5 edges on average instead of 18.9). 



% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name d-cliques/greedy-swap fully-connected --nodes:name 2-shards-uneq-classes iid-uneq-classes --meta:seed 1 --nodes:nb-nodes 1000 1 | python $TOOLS/analyze/diff.py
% Linear
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-07-09:34:29-CEST-labostrex115 all/2021-09-30-11:39:47-CEST-labostrex114 all/2021-09-30-11:40:32-CEST-labostrex115  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 84 --ymax 92.5 --yaxis test-accuracy  --labels 'fully-connected' 'd-cliques (fractal)' 'd-cliques (ring)' --save-figure ../mlsys2022style/figures/d-cliques-scaling-mnist-1000-linear.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3
% Super-Linear
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-07-09:34:29-CEST-labostrex115 all/2021-09-29-22:12:31-CEST-labostrex112 all/2021-09-30-11:40:59-CEST-labostrex116   --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 84 --ymax 92.5 --yaxis test-accuracy  --labels 'fully-connected' 'd-cliques (fully-connected)' 'd-cliques (smallworld)' --save-figure ../mlsys2022style/figures/d-cliques-scaling-mnist-1000-super-linear.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3

\begin{figure}[htbp]
     \centering
     \begin{subfigure}[b]{0.23\textwidth}
         \centering
            \includegraphics[width=\textwidth]{figures/d-cliques-scaling-mnist-1000-linear}
             \caption{\label{fig:d-cliques-scaling-mnist-1000-linear} Linear}
     \end{subfigure}
     \hfill
     \begin{subfigure}[b]{0.23\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-scaling-mnist-1000-super-linear}
\caption{\label{fig:d-cliques-scaling-mnist-1000-super-linear}  Super- and Quasi-Linear}
     \end{subfigure}
\caption{\label{fig:d-cliques-scaling-mnist-1000} MNIST: D-Cliques convergence
speed with 1000 nodes (10 nodes per clique, same number of updates per epoch as 100 nodes, i.e. batch-size 10x less per node) and different inter-clique topologies.}
\end{figure}

% CIFAR10
% python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name d-cliques/greedy-swap fully-connected --nodes:name 2-shards-eq-classes iid-eq-classes --meta:seed 1 --nodes:nb-nodes 1000 1 | python $TOOLS/analyze/diff.py
% Linear
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-07-09:15:23-CEST-labostrex119 all/2021-10-05-19:39:26-CEST-labostrex116 all/2021-10-05-19:40:41-CEST-labostrex119  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 80 --yaxis test-accuracy  --labels 'fully-connected' 'd-cliques (fractal)' 'd-cliques (ring)' --save-figure ../mlsys2022style/figures/d-cliques-scaling-cifar10-1000-linear.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3
% Super-Linear
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-07-09:15:23-CEST-labostrex119 all/2021-10-05-19:38:01-CEST-labostrex114 all/2021-10-05-19:40:04-CEST-labostrex117 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 80 --yaxis test-accuracy  --labels 'fully-connected' 'd-cliques (fully-connected)' 'd-cliques (smallworld)' --save-figure ../mlsys2022style/figures/d-cliques-scaling-cifar10-1000-super-linear.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3
\begin{figure}[htbp]
     \centering
     \begin{subfigure}[b]{0.23\textwidth}
         \centering
            \includegraphics[width=\textwidth]{figures/d-cliques-scaling-cifar10-1000-linear}
             \caption{\label{fig:d-cliques-scaling-cifar10-1000-linear} Linear}
     \end{subfigure}
     \hfill
     \begin{subfigure}[b]{0.23\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-scaling-cifar10-1000-super-linear}
\caption{\label{fig:d-cliques-scaling-cifar10-1000-super-linear}  Super- and Quasi-Linear}
     \end{subfigure}
\caption{\label{fig:d-cliques-scaling-cifar10-1000} CIFAR10: D-Cliques
convergence speed with 1000 nodes (10 nodes per clique, same number of updates per epoch as 100 nodes, i.e. batch-size 10x less per node) and different inter-clique topologies.}
\end{figure}

While the small-world inter-clique topology shows promising scaling behavior, the
fully-connected inter-clique topology still offers
significant benefits with 1000 nodes, as it represents a 98\% reduction in the
number of edges compared to fully connecting individual nodes (18.9 edges on
average instead of 999) and a 96\% reduction in the number of messages (37.8
messages per round per node on average instead of 999). 
We refer to an extended version of this paper~\cite{dcliques-arxiv} for additional results comparing the convergence speed across different number of nodes. 
Overall, these results show that D-Cliques can gracefully scale with the
number of nodes.
  

\subsection{Full Intra-Clique Connectivity is Necessary}

In this experiment, we measure the impact of removing intra-clique edges 
 to assess how critical full connectivity is within cliques. We choose edges to remove
 among the 45 undirected edges present in cliques of size 10. The removal of
 an edge removes the connection in both directions. We remove 1 and 5 edges
 randomly, respectively 2.2\% and 11\% of intra-clique edges. \autoref{fig:d-cliques-mnist-intra-connectivity} 
 shows that for  MNIST, when not using Clique Averaging, 
removing edges decreases slightly the convergence speed and increases 
the variance between nodes. When using Clique Averaging, removing up to 5
edges does not noticeably affect
the convergence speed and variance.

% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name d-cliques/greedy-swap --nodes:name 2-shards-uneq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% w/o Clique Gradient
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-29-03:53:42-CEST-labostrex119 all/2021-10-01-21:44:14-CEST-labostrex113 all/2021-10-02-06:53:40-CEST-labostrex113 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 89 --ymax 92.5 --yaxis test-accuracy --labels 'full intra-connectivity' '-1 edge/clique' '-5 edges/clique' --save-figure ../mlsys2022style/figures/d-cliques-mnist-wo-clique-avg-impact-of-edge-removal.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3
% w/ Clique Gradient
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-23:18:49-CEST-labostrex119 all/2021-10-01-17:08:42-CEST-labostrex113 all/2021-10-02-02:17:43-CEST-labostrex113 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 89 --ymax 92.5 --yaxis test-accuracy  --labels 'full intra-connectivity' '-1 edge/clique' '-5 edges/clique' --save-figure ../mlsys2022style/figures/d-cliques-mnist-w-clique-avg-impact-of-edge-removal.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3
\begin{figure}[htbp]
     \centering

\begin{subfigure}[htbp]{0.23\textwidth}
     \centering   
         \includegraphics[width=\textwidth]{figures/d-cliques-mnist-wo-clique-avg-impact-of-edge-removal}     
\caption{\label{fig:d-cliques-mnist-wo-clique-avg-impact-of-edge-removal} Without Clique Averaging }
\end{subfigure}
\hfill
\begin{subfigure}[htbp]{0.23\textwidth}
     \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-mnist-w-clique-avg-impact-of-edge-removal}
\caption{\label{fig:d-cliques-mnist-w-clique-avg-impact-of-edge-removal} With Clique Averaging}
\end{subfigure}
\caption{\label{fig:d-cliques-mnist-intra-connectivity} MNIST: Impact of
intra-clique edge removal on D-Cliques (fully-connected) with 10
cliques of 10 heterogeneous nodes (100 nodes). Y axis starts at 89.}
\end{figure}

In contrast, \autoref{fig:d-cliques-cifar10-intra-connectivity} shows that for CIFAR10, the impact is stronger. We show the results with and without Clique Averaging
with momentum in both cases, as momentum is critical for obtaining the best
convergence speed on CIFAR10. Without Clique Averaging,
removing edges has a small effect on convergence speed and variance, but the convergence speed is too slow to be practical.
With Clique Averaging, removing a single edge has a small but noticeable
effect. Strikingly, removing 5 edges per clique significantly damages the
convergence and yields a sharp increase in the variance across nodes.
Therefore, while D-Cliques can tolerate the removal of some intra-clique edges
when training simple linear models and datasets as in MNIST, fast
convergence speed and low variance requires full or nearly full connectivity
when using high-capacity models and more difficult datasets. This is
in line with the observations made in Section~\ref{sec:exp:clique_avg}
regarding the effect of Clique Averaging. Again, these results show the
relevance of our design choices, including the choice of constructing fully
connected cliques.
% CIFAR10
% python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name d-cliques/greedy-swap --nodes:name 2-shards-eq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% w/o Clique Gradient
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-04-03:13:46-CEST-labostrex117 all/2021-10-06-17:58:49-CEST-labostrex112 all/2021-10-06-17:45:22-CEST-labostrex115  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 80 --yaxis test-accuracy --labels 'full intra-connectivity' '-1 edge/clique' '-5 edges/clique' --save-figure ../mlsys2022style/figures/d-cliques-cifar10-wo-clique-avg-impact-of-edge-removal.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3
% w/ Clique Gradient
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-19:53:21-CEST-labostrex117 all/2021-10-06-12:46:49-CEST-labostrex112 all/2021-10-06-12:49:51-CEST-labostrex115 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 80 --yaxis test-accuracy --labels 'full intra-connectivity' '-1 edge/clique' '-5 edges/clique' --save-figure ../mlsys2022style/figures/d-cliques-cifar10-w-clique-avg-impact-of-edge-removal.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3

\begin{figure}[htbp]
     \centering
\begin{subfigure}[htbp]{0.23\textwidth}
     \centering   
         \includegraphics[width=\textwidth]{figures/d-cliques-cifar10-wo-clique-avg-impact-of-edge-removal}     
\caption{\label{fig:d-cliques-cifar10-wo-clique-avg-impact-of-edge-removal} Without Clique Averaging }
\end{subfigure}
\hfill
\begin{subfigure}[htbp]{0.23\textwidth}
     \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-cifar10-w-clique-avg-impact-of-edge-removal}
\caption{\label{fig:d-cliques-cifar10-w-clique-avg-impact-of-edge-removal} With Clique Averaging}
\end{subfigure}
\caption{\label{fig:d-cliques-cifar10-intra-connectivity} CIFAR10: Impact of intra-clique edge removal (with momentum) on D-Cliques (fully-connected) with 10 cliques of 10 heterogeneous nodes (100 nodes).}
\end{figure}

\subsection{Greedy Swap Improves Random Cliques at an Affordable Cost}
\label{section:greedy-swap-vs-random-cliques}

In the next two sub-sections, we compare cliques built with Greedy Swap (Alg.~\ref{Algorithm:greedy-swap})
to Random Cliques, a simple and obvious baseline, on their quality (skew),  the cost 
of their construction, and their convergence speed.

\subsubsection{Cliques with Low Skew can be Constructed Efficiently with Greedy Swap}
\label{section:cost-cliques}

We compared the final average skew of 10 cliques with 10 nodes each (for
$n=100$) created either randomly or with Greedy Swap,
over 100 experiments after 1000 steps. \autoref{fig:skew-convergence-speed-2-shards}, in the form of an histogram,
 shows that Greedy Swap generates cliques of significantly lower skew, close to 0 in a majority of cases for both MNIST and CIFAR10.

% MNIST
% python $TOOLS/plot/skew/final-distribution.py --rundirs skews-mnist/* --save-figure ../mlsys2022style/figures/final-skew-distribution-mnist.png --labels 'Greedy Swap' 'Random Cliques' --linewidth 2.5 --font-size 18 --linestyles 'solid' 'dashed'
% CIFAR10
% python $TOOLS/plot/skew/final-distribution.py --rundirs skews-cifar10/* --save-figure ../mlsys2022style/figures/final-skew-distribution-cifar10.png --labels 'Greedy Swap' 'Random Cliques' --linewidth 2.5 --font-size 18 --linestyles 'solid' 'dashed'

\begin{figure}[htbp]
    \centering        
    \begin{subfigure}[b]{0.2\textwidth}
    \centering
    \includegraphics[width=\textwidth]{figures/final-skew-distribution-mnist}
    \caption{\label{fig:final-skew-distribution-mnist} MNIST }
    \end{subfigure}
    \hfill
    \begin{subfigure}[b]{0.2\textwidth}
    \centering
    \includegraphics[width=\textwidth]{figures/final-skew-distribution-cifar10}
    \caption{\label{fig:final-skew-distribution-cifar10} CIFAR10}
    \end{subfigure}
\caption{\label{fig:final-skew-distribution} Final quality of cliques (skew) with a maximum size of 10 over 100 experiments in a network of 100 nodes.}
\end{figure}

\autoref{fig:skew-convergence-speed-2-shards} shows such a low skew can be achieved 
in less than 400 steps for both MNIST and CIFAR10. In practice it takes less
than 6 seconds in Python 3.7 on a 
Macbook Pro 2020 for a network of 100 nodes and cliques of size 10. Greedy Swap 
is therefore fast and efficient. Moreover, it illustrates the fact that a
global imbalance in the number of examples
across classes makes the construction of cliques with low skew harder and
slower.

%python $TOOLS/analyze/filter.py skews --topology:name d-cliques/greedy-swap | python $TOOLS/plot/skew/convergence.py --max-steps 400 --labels 'MNIST (unbalanced classes)' 'CIFAR10 (balanced classes)' --linewidth 2.5 --save-figure ../mlsys2022style/figures/skew-convergence-speed-2-shards.png --linestyles 'solid' 'dashed'
\begin{figure}[htbp]
    \centering
    \includegraphics[width=0.23\textwidth]{figures/skew-convergence-speed-2-shards}
    \caption{\label{fig:skew-convergence-speed-2-shards} Skew decrease during clique construction of 10 cliques of 10 heterogeneous nodes (100 nodes). Bold line is the average over 100 experiments. Thin lines are respectively the minimum and maximum over all experiments. In wall-clock time, 1000 steps take less than 6 seconds in Python 3.7 on a MacBook Pro 2020.}
\end{figure}

\subsubsection{Cliques built with Greedy Swap Converge Faster than Random Cliques}

\autoref{fig:convergence-speed-dc-random-vs-dc-gs-2-shards-per-node} compares
the convergence speed of cliques optimized with Greedy Swap for 1000 steps with cliques built randomly 
(equivalent to Greedy Swap with 0 steps). For both MNIST and CIFAR10, convergence speed
increases significantly and variance between nodes decreases dramatically. Decreasing the skew of cliques
is therefore critical to convergence speed.

% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name d-cliques/random-cliques d-cliques/greedy-swap --nodes:name 2-shards-uneq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs  all/2021-09-28-23:18:49-CEST-labostrex119 all/2021-09-29-22:12:59-CEST-labostrex114 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 80 --ymax 92.5 --yaxis test-accuracy --labels 'd-cliques greedy-swap' 'd-cliques random'  --save-figure ../mlsys2022style/figures/convergence-speed-mnist-dc-random-vs-dc-gs-2-shards-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3
% CIFAR10
%  python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name d-cliques/random-cliques d-cliques/greedy-swap --nodes:name 2-shards-eq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs  all/2021-10-03-19:53:21-CEST-labostrex117 all/2021-10-04-21:18:33-CEST-labostrex117 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 100 --yaxis test-accuracy --labels 'd-cliques greedy-swap'  'd-cliques random' --save-figure ../mlsys2022style/figures/convergence-speed-cifar10-dc-random-vs-dc-gs-2-shards-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3

\begin{figure}[htbp]
    \centering        
    \begin{subfigure}[b]{0.23\textwidth}
    \centering
    \includegraphics[width=\textwidth]{figures/convergence-speed-mnist-dc-random-vs-dc-gs-2-shards-per-node}
    \caption{\label{fig:convergence-speed-mnist-dc-random-vs-dc-gs-2-shards-per-node} MNIST}
    \end{subfigure}
    \hfill
    \begin{subfigure}[b]{0.23\textwidth}
    \centering
    \includegraphics[width=\textwidth]{figures/convergence-speed-cifar10-dc-random-vs-dc-gs-2-shards-per-node}
    \caption{\label{fig:convergence-speed-cifar10-dc-random-vs-dc-gs-2-shards-per-node} CIFAR10}
    \end{subfigure}
\caption{\label{fig:convergence-speed-dc-random-vs-dc-gs-2-shards-per-node} Convergence speed of D-Cliques constructed randomly vs Greedy Swap with 10 cliques of 10 heterogeneous nodes (100 nodes).}
\end{figure}

\subsection{Additional Experiments on Extreme Label Distribution Skew}

In an extended version of this paper~\cite{dcliques-arxiv}, we replicate experimental
results on an extreme case of label distribution skew where each node only has
examples of a single class. These results consistently show that our
approach remains effective even for extremely skewed label distributions.
